import sys
import os
import time
import random
import re

#
def randomWidthGenerator(n):
    width = random.randrange(n)
    word = ''
    for i in range(width):
        word = ''.join((word,chr(random.randrange(32,127))))
    return(word)

# stored in each row
def matrixGenerator_Rows(total_Rows,total_Cols,n):
    matrix = {}
    for i in range(1,total_Rows+1):
        matrix[i] = {}
        for j in range(1,total_Cols+1):
            matrix[i][j] = randomWidthGenerator(n)
    return(matrix)

# stored in each col
def matrixGenerator_Cols(total_Rows,total_Cols,n):
    matrix = {}
    for i in range(1,total_Cols+1):
        matrix[i] = {}
        for j in range(1,total_Rows+1):
            matrix[i][j] = randomWidthGenerator(n)
    return(matrix)

def maxWidth(myDict):
    maxValueWidth = 0
    for each in myDict:
        eachValueWidth = myDict[each].__len__()
        if(eachValueWidth > maxValueWidth):
            maxValueWidth = eachValueWidth
    return(maxValueWidth)
#

def display_Width(s):
    width = 0
    len = s.__len__()
    for i in range(0,len):
        sublen = s[i].encode().__len__()
        sublen = int(sublen/2 + 1/2)
        width = width + sublen
    return(width)

def max_Display_Width(myDict):
    maxValueWidth = 0
    for each in myDict:
        eachValueWidth = display_Width(myDict[each])
        if(eachValueWidth > maxValueWidth):
            maxValueWidth = eachValueWidth
    return(maxValueWidth)

# 
def max_Rows(COLs):
    max = 0
    total_Cols = COLs.__len__()
    for i in range(1,total_Cols + 1):
        if(COLs[i].__len__()>max):
            max = COLs[i].__len__()
    return(max)

# 
def max_Cols(ROWs):
    max = 0
    total_Rows = ROWs.__len__()
    for i in range(1,total_Rows + 1):
        if(ROWs[i].__len__()>max):
            max = ROWs[i].__len__()
    return(max)


def padding_Rows(ROWs):
    max = max_Cols(ROWs)
    total_Rows = ROWs.__len__()
    for i in range(1,total_Rows + 1):
        if(ROWs[i].__len__()<max):
            for j in range(1,max + 1):
                if j in ROWs[i]:
                    pass
                else:
                    ROWs[i][j] = ''
    return(ROWs)

def padding_Cols(COLs):
    max = max_Rows(COLs)
    total_Cols = COLs.__len__()
    for i in range(1,total_Cols + 1):
        if(COLs[i].__len__()<max):
            for j in range(1,max + 1):
                if j in COLs[i]:
                    pass
                else:
                    COLs[i][j] = ''
    return(COLs)

def ROWs_To_COLs(ROWs):
    COLs = {}
    total_Cols = max_Cols(ROWs)
    for i in range(1,total_Cols + 1):
        COLs[i] = {}
    total_Rows = ROWs.__len__()
    for i in range(1,total_Cols + 1):
        for j in range(1,total_Rows + 1):
            COLs[i][j] = ROWs[j][i]
    return(COLs)


def COLs_To_ROWs(COLs):
    ROWs = {}
    total_Rows = max_Rows(COLs)
    for i in range(1,total_Rows + 1):
        ROWs[i] = {}
    total_Cols = COLs.__len__()
    for i in range(1,total_Rows + 1):
        for j in range(1,total_Cols + 1):
            ROWs[i][j] = COLs[j][i]
    return(ROWs)


# COLs = matrixGenerator_Cols(5,4,10)
# COLs = padding_Cols(COLs)
# ROWs = COLs_To_ROWs(COLs)

# ROWs = matrixGenerator_Rows(5,4,10)
# ROWs = padding_Rows(ROWs)
# COLs = ROWs_To_COLs(ROWs)


def extend_Str(s,mw):
    w = display_Width(s)
    space_Len = mw - w
    new_S = ''
    for i in range(0,space_Len):
        new_S = ''.join((' ' , new_S))
    new_S = ''.join((new_S,s))
    return(new_S)

def display_Rows(ROWs):
    COLs = ROWs_To_COLs(ROWs)
    display_COLs = {}
    widths = {}
    widths[1] =  max_Display_Width(COLs[1])
    display_COLs[1] = {}
    for j in range(1,COLs[1].__len__()+1):
        display_COLs[1][j] = '|{0}|'.format(extend_Str(COLs[1][j],widths[1]))
    for i in range(2,COLs.__len__()+1):
        widths[i] =  max_Display_Width(COLs[i])
        display_COLs[i] = {}
        for j in range(1,COLs[i].__len__()+1):
            display_COLs[i][j] = '{0}|'.format(extend_Str(COLs[i][j],widths[i]))
    boundary = '+'
    for i in range (1,widths.__len__()+1):
        boundary = '{0}{1}+'.format(boundary,'+'*widths[i])
    print(boundary)
    for i in range(1,ROWs.__len__()+1):
        for j in range(1,COLs.__len__()+1):
            print(display_COLs[j][i],end='')
        print('\n',end='')
        print(boundary)

# ++++++++++++++++++++++++++++++++++++++
# | $;6s?| `9.r?Dxi|         |  xiySyse|
# ++++++++++++++++++++++++++++++++++++++
# |      |  X0y{'Ma|     ))T0|        <|
# ++++++++++++++++++++++++++++++++++++++
# |  xl-5|b>!Ah}i5}|      WnK|         |
# ++++++++++++++++++++++++++++++++++++++
# |]0#A>I|      OY6|   q{ne_@|y;z41ruGl|
# ++++++++++++++++++++++++++++++++++++++
# |   >Yz|     pX=,|YuDSJZ[t |      a=L|
# ++++++++++++++++++++++++++++++++++++++

def display_Cols(COLs):
    ROWs = ROWs_To_COLs(COLs)
    display_COLs = {}
    widths = {}
    widths[1] =  max_Display_Width(COLs[1])
    display_COLs[1] = {}
    for j in range(1,COLs[1].__len__()+1):
        display_COLs[1][j] = '|{0}|'.format(extend_Str(COLs[1][j],widths[1]))
    for i in range(2,COLs.__len__()+1):
        widths[i] =  max_Display_Width(COLs[i])
        display_COLs[i] = {}
        for j in range(1,COLs[i].__len__()+1):
            display_COLs[i][j] = '{0}|'.format(extend_Str(COLs[i][j],widths[i]))
    boundary = '+'
    for i in range (1,widths.__len__()+1):
        boundary = '{0}{1}+'.format(boundary,'+'*widths[i])
    print(boundary)
    for i in range(1,ROWs.__len__()+1):
        for j in range(1,COLs.__len__()+1):
            print(display_COLs[j][i],end='')
        print('\n',end='')
        print(boundary)
##########################
